﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ESRI.ArcGIS.esriSystem;
using ESRI.ArcGIS.Controls;
using ESRI.ArcGIS.Display;
using ESRI.ArcGIS.Carto;
using ESRI.ArcGIS.Geodatabase;
using ESRI.ArcGIS.DataSourcesGDB;
using ESRI.ArcGIS.NetworkAnalysis;
using ESRI.ArcGIS.Geometry;
using ESRI.ArcGIS.NetworkAnalyst;

namespace NET
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        INetworkDataset NetData;
        INAContext _Context;
        IPointCollection m_ipPoints;
        ISpatialReference spatialRef;
        IGraphicsContainer pGC;

         

        bool IsAnlysis = false;
      
        ClsPathFinder m_ipPathFinder = null;
        private void start_Click(object sender, EventArgs e)
        {

            if (m_ipPathFinder == null)//打开网络空间
            {

                m_ipPathFinder = new ClsPathFinder();
                IMap ipMap = this.axMapControl1.ActiveView.FocusMap;
                if (ipMap.LayerCount == 0)
                { MessageBox.Show("没有图层不能进行网络分析"); return; }
                for (int i = 0; i < ipMap.LayerCount; i++)
                {
                    ILayer ipLayer = ipMap.get_Layer(i);
                    INetworkLayer ipFLayer = ipLayer as INetworkLayer;
                    if (ipFLayer != null)
                    {
                        NetData = ipFLayer.NetworkDataset;
                        spatialRef = m_ipPathFinder.GetSpatialReferenceFromDataset(NetData as IDataset);

                    }
                }
            }

           
           
            pGC = axMapControl1.ActiveView.FocusMap  as IGraphicsContainer;
            _Context = m_ipPathFinder.CreateSolverContext(NetData );
           


        }

       
     













         private void add_Click(object sender, EventArgs e)
        {
           
            IsAnlysis = true;
            MessageBox.Show("ADD POINTS");



        }

        private void solve_Click(object sender, EventArgs e)
         {
             IFeatureLayer featurelayer = ClsPathFinder.CreateFeatureLayerInmemeory("PointsLayer", "PointsLayer", spatialRef, esriGeometryType.esriGeometryPoint, null);
             axMapControl1.Map.AddLayer(featurelayer as ILayer);
             axMapControl1.Refresh();
             m_ipPathFinder.CreateFeature(  featurelayer.FeatureClass, m_ipPoints);
             m_ipPathFinder.LoadNANetworkLocations("Stops", featurelayer.FeatureClass, 80, _Context);
             m_ipPathFinder.SetSolverSettings(_Context);
             m_ipPathFinder.Solve(_Context);


             ILayer layer1;
             INALayer naLayer = _Context.Solver.CreateLayer(_Context);
             layer1 = naLayer as ILayer;
             layer1.Name = _Context.Solver.DisplayName;
             axMapControl1.AddLayer(layer1, 0);


            
            IsAnlysis = false;


        }

        private void axMapControl1_OnMouseDown(object sender, IMapControlEvents2_OnMouseDownEvent e)
        {
            if (IsAnlysis == false)
                return;
           
            IPoint ipNew;
            if (m_ipPoints == null)
            {
                m_ipPoints = new MultipointClass();
               
            }

            ipNew = this.axMapControl1.ActiveView.ScreenDisplay.DisplayTransformation.ToMapPoint(e.x, e.y);
            IElement Element = showPoint(m_ipPoints.PointCount);
            Element.Geometry = axMapControl1.ActiveView.ScreenDisplay.DisplayTransformation.ToMapPoint(e.x, e.y);
            pGC.AddElement(Element , 0);
            axMapControl1.ActiveView.PartialRefresh(esriViewDrawPhase.esriViewGraphics, null, null);
            object o = Type.Missing;
            m_ipPoints.AddPoint(ipNew, ref o, ref o);

        }



        private IElement showPoint(int cout)
        {
           IElement   element;
            ITextElement textelement = new TextElementClass();
            element = textelement as IElement;
            ITextSymbol textSymbol = new TextSymbol();
            IRgbColor color = new RgbColorClass();
            color.Blue = 255;
            color.Green = 0;
            color.Red = 0;



            textSymbol.Color = color;
            textSymbol.Size = 30;
            textelement.Symbol = textSymbol;

            textelement.Text = cout.ToString();
            return element;
        }
    }
}
